#!/bin/sh

extract () {
  if [ -f "$1" ] ; then
    case "$1" in
      *.tar.bz2)   tar xvjf "$1"    ;;
      *.tar.gz)    tar xvzf "$1"    ;;
      *.bz2)       bunzip2 "$1"     ;;
      *.rar)       unrar x "$1"     ;;
      *.gz)        gunzip "$1"      ;;
      *.tar)       tar xvf "$1"     ;;
      *.tbz2)      tar xvjf "$1"    ;;
      *.tgz)       tar xvzf "$1"    ;;
      *.zip)       unzip "$1"       ;;
      *.Z)         uncompress "$1"  ;;
      *.7z)        7z x "$1"        ;;
      *.xz)        unxz "$1"        ;;
      *)           echo "don't know how to extract '$1'..." ;;
    esac
  else
    echo "'$1' is not a valid file!"
  fi
}

genpassword() {
  length="${1-99}"
  tr -cd '[:alnum:]' < /dev/urandom | fold "-w$length" | head -n1 ||:
}

t() {
  expand "$1" -t2 | sponge "$1"
}

task() {
  TITLE="${1:-FIXME}"
  printf '## TODO %s {#task-%s}\n- TODO in %s\n\n---\n\nFIXME\n' \
         "$TITLE" "$(uuidgen)" "$(date -I)"                                            | \
    vipe                                                                               | \
    printf '%s\n\n%s\n\n%s\n' "$(head -n2 TODOs.md)" "$(cat -)" "$(tail -n+3 TODOs.md)"  | \
    sponge TODOs.md
}

gvi() {
  if [ -e "$1" ]; then
    INIT="gpg -qd"
  else
    INIT="echo"
  fi
  $INIT "$1" | vipe | gpg -qer eu@euandre.org | sponge "$1"
}
